package at.ac.uibk.gitsearch.domain;

import org.hibernate.annotations.Cache;
import org.hibernate.annotations.CacheConcurrencyStrategy;

import javax.persistence.*;
import javax.validation.constraints.*;

import java.io.Serializable;

/**
 * A Statistics.
 */
@Entity
@Table(name = "statistics")
@Cache(usage = CacheConcurrencyStrategy.READ_WRITE)
@org.springframework.data.elasticsearch.annotations.Document(indexName = "statistics")
public class Statistics implements Serializable {

    private static final long serialVersionUID = 1L;

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

    @Column(name = "views")
    private Integer views;

    @NotNull
    @Column(name = "downloads", nullable = false)
    private Integer downloads;

    @Column(name = "exercise_id")
    private Long exerciseID;

    // jhipster-needle-entity-add-field - JHipster will add fields here
    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public Integer getViews() {
        return views;
    }

    public Statistics views(Integer views) {
        this.views = views;
        return this;
    }

    public void setViews(Integer views) {
        this.views = views;
    }

    public Integer getDownloads() {
        return downloads;
    }

    public Statistics downloads(Integer downloads) {
        this.downloads = downloads;
        return this;
    }

    public void setDownloads(Integer downloads) {
        this.downloads = downloads;
    }

    public Long getExerciseID() {
        return exerciseID;
    }

    public Statistics exerciseID(Long exerciseID) {
        this.exerciseID = exerciseID;
        return this;
    }

    public void setExerciseID(Long exerciseID) {
        this.exerciseID = exerciseID;
    }
    // jhipster-needle-entity-add-getters-setters - JHipster will add getters and setters here

    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (!(o instanceof Statistics)) {
            return false;
        }
        return id != null && id.equals(((Statistics) o).id);
    }

    @Override
    public int hashCode() {
        return 31;
    }

    // prettier-ignore
    @Override
    public String toString() {
        return "Statistics{" +
            "id=" + getId() +
            ", views=" + getViews() +
            ", downloads=" + getDownloads() +
            ", exerciseID=" + getExerciseID() +
            "}";
    }
}
