package at.ac.uibk.gitsearch.service.dto;

import javax.validation.constraints.*;
import java.io.Serializable;
import at.ac.uibk.gitsearch.domain.enumeration.CheckFrequency;

/**
 * A DTO for the {@link at.ac.uibk.gitsearch.domain.UserWatchList} entity.
 */
public class UserWatchListDTO implements Serializable {
    
    /**
	 * 
	 */
	private static final long serialVersionUID = 1L;

    private Long id;

    @NotNull
    @Size(min = 1)
    private String name;

    @NotNull
    private CheckFrequency checkFrequency;


    private Long userId;

    private String userLogin;
    
    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public CheckFrequency getCheckFrequency() {
        return checkFrequency;
    }

    public void setCheckFrequency(CheckFrequency checkFrequency) {
        this.checkFrequency = checkFrequency;
    }

    public Long getUserId() {
        return userId;
    }

    public void setUserId(Long userId) {
        this.userId = userId;
    }

    public String getUserLogin() {
        return userLogin;
    }

    public void setUserLogin(String userLogin) {
        this.userLogin = userLogin;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (!(o instanceof UserWatchListDTO)) {
            return false;
        }

        return id != null && id.equals(((UserWatchListDTO) o).id);
    }

    @Override
    public int hashCode() {
        return 31;
    }

    // prettier-ignore
    @Override
    public String toString() {
        return "UserWatchListDTO{" +
            "id=" + getId() +
            ", name='" + getName() + "'" +
            ", checkFrequency='" + getCheckFrequency() + "'" +
            ", userIdId=" + getUserId() +
            ", userIdLogin='" + getUserLogin() + "'" +
            "}";
    }
}
